
_XBee_TX:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SUBI       R28, 121
	SBCI       R29, 0
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;LQd_XBee.mbas,29 :: 		total_lgth as byte
;LQd_XBee.mbas,31 :: 		packet[0] = 0x7E
	LDI        R27, 126
	STD        Y+0, R27
;LQd_XBee.mbas,32 :: 		packet[1] = 0x00
	LDI        R27, 0
	STD        Y+1, R27
;LQd_XBee.mbas,33 :: 		packet[2] = msg_lgth + 14
	MOV        R16, R8
	SUBI       R16, 242
	STD        Y+2, R16
;LQd_XBee.mbas,34 :: 		packet[3] = 0x10
	LDI        R27, 16
	STD        Y+3, R27
;LQd_XBee.mbas,35 :: 		packet[4] = 0x00     ' frame_id, 00: no response with TX status
	LDI        R27, 0
	STD        Y+4, R27
;LQd_XBee.mbas,36 :: 		packet[5] = Highest(hi_adr)
	MOVW       R16, R2
	SUBI       R16, 253
	SBCI       R17, 255
	MOVW       R30, R16
	LD         R16, Z
	STD        Y+5, R16
;LQd_XBee.mbas,37 :: 		packet[6] = Higher(hi_adr)
	MOVW       R16, R2
	SUBI       R16, 254
	SBCI       R17, 255
	MOVW       R30, R16
	LD         R16, Z
	STD        Y+6, R16
;LQd_XBee.mbas,38 :: 		packet[7] = Hi(hi_adr)
	MOVW       R16, R2
	SUBI       R16, 255
	SBCI       R17, 255
	MOVW       R30, R16
	LD         R16, Z
	STD        Y+7, R16
;LQd_XBee.mbas,39 :: 		packet[8] = Lo(hi_adr)
	MOVW       R30, R2
	LD         R16, Z
	STD        Y+8, R16
;LQd_XBee.mbas,40 :: 		packet[9] = Highest(lo_adr)
	MOVW       R16, R4
	SUBI       R16, 253
	SBCI       R17, 255
	MOVW       R30, R16
	LD         R16, Z
	STD        Y+9, R16
;LQd_XBee.mbas,41 :: 		packet[10] = Higher(lo_adr)
	MOVW       R16, R4
	SUBI       R16, 254
	SBCI       R17, 255
	MOVW       R30, R16
	LD         R16, Z
	STD        Y+10, R16
;LQd_XBee.mbas,42 :: 		packet[11] = Hi(lo_adr)
	MOVW       R16, R4
	SUBI       R16, 255
	SBCI       R17, 255
	MOVW       R30, R16
	LD         R16, Z
	STD        Y+11, R16
;LQd_XBee.mbas,43 :: 		packet[12] = Lo(lo_adr)
	MOVW       R30, R4
	LD         R16, Z
	STD        Y+12, R16
;LQd_XBee.mbas,44 :: 		packet[13] = 0xFF
	LDI        R27, 255
	STD        Y+13, R27
;LQd_XBee.mbas,45 :: 		packet[14] = 0xFE
	LDI        R27, 254
	STD        Y+14, R27
;LQd_XBee.mbas,46 :: 		packet[15] = 0x00  ' broadcast radius at max, if you need different, set it here or pass another parameter
	LDI        R27, 0
	STD        Y+15, R27
;LQd_XBee.mbas,47 :: 		packet[16] = 0x00  ' transmit options: 00 default, 0x01: Disable ACK, 0x02: Don't attempt route Discovery
	LDI        R27, 0
	STD        Y+16, R27
;LQd_XBee.mbas,49 :: 		total_lgth = 16 + msg_lgth + 1
	MOV        R16, R8
	SUBI       R16, 240
	SUBI       R16, 255
; total_lgth start address is: 20 (R20)
	MOV        R20, R16
;LQd_XBee.mbas,52 :: 		for i = 1 to msg_lgth
; i start address is: 21 (R21)
	LDI        R21, 1
; i end address is: 21 (R21)
; total_lgth end address is: 20 (R20)
L__XBee_TX1:
; i start address is: 21 (R21)
; total_lgth start address is: 20 (R20)
	CP         R8, R21
	BRSH       L__XBee_TX173
	JMP        L__XBee_TX5
L__XBee_TX173:
;LQd_XBee.mbas,53 :: 		packet[i + 16] = msg[i - 1]
	MOV        R18, R21
	SUBI       R18, 240
	MOVW       R16, R28
	LDI        R19, 0
	ADD        R18, R16
	ADC        R19, R17
	MOV        R16, R21
	SUBI       R16, 1
	LDI        R17, 0
	ADD        R16, R6
	ADC        R17, R7
	MOVW       R30, R16
	LD         R16, Z
	MOVW       R30, R18
	ST         Z, R16
;LQd_XBee.mbas,54 :: 		next i
	CP         R21, R8
	BRNE       L__XBee_TX174
	JMP        L__XBee_TX5
L__XBee_TX174:
	MOV        R16, R21
	SUBI       R16, 255
	MOV        R21, R16
; i end address is: 21 (R21)
	JMP        L__XBee_TX1
L__XBee_TX5:
;LQd_XBee.mbas,56 :: 		checksum_temp = 0
; checksum_temp start address is: 21 (R21)
	LDI        R21, 0
	LDI        R22, 0
;LQd_XBee.mbas,57 :: 		for i = 3 to (16 + msg_lgth)
; i start address is: 19 (R19)
	LDI        R19, 3
; total_lgth end address is: 20 (R20)
; i end address is: 19 (R19)
; checksum_temp end address is: 21 (R21)
L__XBee_TX6:
; i start address is: 19 (R19)
; checksum_temp start address is: 21 (R21)
; total_lgth start address is: 20 (R20)
	MOV        R18, R8
	SUBI       R18, 240
	CP         R18, R19
	BRSH       L__XBee_TX175
	JMP        L__XBee_TX154
L__XBee_TX175:
;LQd_XBee.mbas,58 :: 		checksum_temp = checksum_temp + packet[i]                                                          ' otestovat checksum temp ako bajt  //////////////////////////////
	MOVW       R16, R28
	ADD        R16, R19
	LDI        R27, 0
	ADC        R17, R27
	MOVW       R30, R16
	LD         R16, Z
	LDI        R17, 0
	ADD        R16, R21
	ADC        R17, R22
; checksum_temp end address is: 21 (R21)
; checksum_temp start address is: 23 (R23)
	MOV        R23, R16
	MOV        R24, R17
;LQd_XBee.mbas,59 :: 		next i
	CP         R19, R18
	BRNE       L__XBee_TX176
	JMP        L__XBee_TX153
L__XBee_TX176:
	MOV        R16, R19
	SUBI       R16, 255
	MOV        R19, R16
; checksum_temp end address is: 23 (R23)
; i end address is: 19 (R19)
	MOV        R21, R23
	MOV        R22, R24
	JMP        L__XBee_TX6
L__XBee_TX153:
	MOV        R21, R23
	MOV        R22, R24
	JMP        L__XBee_TX10
L__XBee_TX154:
;LQd_XBee.mbas,57 :: 		for i = 3 to (16 + msg_lgth)
;LQd_XBee.mbas,59 :: 		next i
L__XBee_TX10:
;LQd_XBee.mbas,60 :: 		packet[total_lgth] = 0xFF - Lo(checksum_temp)
; checksum_temp start address is: 21 (R21)
	MOVW       R16, R28
	MOV        R18, R20
	LDI        R19, 0
	ADD        R18, R16
	ADC        R19, R17
	LDI        R16, 255
	SUB        R16, R21
; checksum_temp end address is: 21 (R21)
	MOVW       R30, R18
	ST         Z, R16
;LQd_XBee.mbas,62 :: 		for i = 0 to total_lgth
; i start address is: 18 (R18)
	LDI        R18, 0
; total_lgth end address is: 20 (R20)
; i end address is: 18 (R18)
	MOV        R19, R20
L__XBee_TX11:
; i start address is: 18 (R18)
; total_lgth start address is: 19 (R19)
	CP         R19, R18
	BRSH       L__XBee_TX177
	JMP        L__XBee_TX15
L__XBee_TX177:
;LQd_XBee.mbas,63 :: 		UART2_Write(packet[i])
	MOVW       R16, R28
	ADD        R16, R18
	LDI        R27, 0
	ADC        R17, R27
	MOVW       R30, R16
	LD         R16, Z
	PUSH       R3
	PUSH       R2
	MOV        R2, R16
	CALL       _UART2_Write+0
; total_lgth end address is: 19 (R19)
	POP        R2
	POP        R3
	MOV        R17, R19
;LQd_XBee.mbas,64 :: 		while UART2_Tx_Idle() = 0
	JMP        L__XBee_TX17
L__XBee_TX155:
L__XBee_TX17:
; total_lgth start address is: 17 (R17)
; total_lgth start address is: 17 (R17)
; total_lgth end address is: 17 (R17)
; i start address is: 18 (R18)
; i end address is: 18 (R18)
	PUSH       R17
	CALL       _UART2_Tx_Idle+0
	POP        R17
	CPI        R16, 0
	BRNE       L__XBee_TX178
	JMP        L__XBee_TX155
L__XBee_TX178:
; total_lgth end address is: 17 (R17)
; i end address is: 18 (R18)
;LQd_XBee.mbas,66 :: 		next i
; i start address is: 18 (R18)
; total_lgth start address is: 17 (R17)
	CP         R18, R17
	BRNE       L__XBee_TX179
	JMP        L__XBee_TX15
L__XBee_TX179:
	MOV        R16, R18
	SUBI       R16, 255
	MOV        R18, R16
	MOV        R19, R17
; total_lgth end address is: 17 (R17)
; i end address is: 18 (R18)
	JMP        L__XBee_TX11
L__XBee_TX15:
;LQd_XBee.mbas,68 :: 		result = 2
; Result start address is: 17 (R17)
	LDI        R17, 2
;LQd_XBee.mbas,70 :: 		end sub
	MOV        R16, R17
; Result end address is: 17 (R17)
L_end_XBee_TX:
	SUBI       R28, 136
	SBCI       R29, 255
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _XBee_TX

_XBee_AT_Command:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SBIW       R28, 13
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;LQd_XBee.mbas,75 :: 		i as byte
;LQd_XBee.mbas,77 :: 		packet[0] = 0x7E
	LDI        R27, 126
	STD        Y+0, R27
;LQd_XBee.mbas,78 :: 		packet[1] = 0x00
	LDI        R27, 0
	STD        Y+1, R27
;LQd_XBee.mbas,79 :: 		packet[3] = 0x08
	LDI        R27, 8
	STD        Y+3, R27
;LQd_XBee.mbas,80 :: 		packet[4] = frameID
	STD        Y+4, R2
;LQd_XBee.mbas,81 :: 		packet[5] = ATcommand[0]
	MOV        R30, R3
	MOV        R31, R4
	LD         R16, Z
	STD        Y+5, R16
;LQd_XBee.mbas,82 :: 		packet[6] = ATcommand[1]
	MOV        R30, R3
	MOV        R31, R4
	ADIW       R30, 1
	LD         R16, Z
	STD        Y+6, R16
;LQd_XBee.mbas,84 :: 		if query <> 0 then
	LDI        R27, 0
	CP         R9, R27
	BRNE       L__XBee_AT_Command181
	JMP        L__XBee_AT_Command23
L__XBee_AT_Command181:
;LQd_XBee.mbas,85 :: 		packet[7] =  highest(parameter)
	STD        Y+7, R8
;LQd_XBee.mbas,86 :: 		packet[8] =  higher(parameter)
	STD        Y+8, R7
;LQd_XBee.mbas,87 :: 		packet[9] =  hi(parameter)
	STD        Y+9, R6
;LQd_XBee.mbas,88 :: 		packet[10] = lo(parameter)
	STD        Y+10, R5
;LQd_XBee.mbas,89 :: 		packet[2] = 8
	LDI        R27, 8
	STD        Y+2, R27
	JMP        L__XBee_AT_Command24
;LQd_XBee.mbas,90 :: 		else
L__XBee_AT_Command23:
;LQd_XBee.mbas,91 :: 		packet[2] = 4
	LDI        R27, 4
	STD        Y+2, R27
;LQd_XBee.mbas,92 :: 		end if
L__XBee_AT_Command24:
;LQd_XBee.mbas,94 :: 		checksum_temp = 0
; checksum_temp start address is: 20 (R20)
	LDI        R20, 0
	LDI        R21, 0
;LQd_XBee.mbas,95 :: 		for i = 3 to (packet[2] + 2)
; i start address is: 19 (R19)
	LDI        R19, 3
; checksum_temp end address is: 20 (R20)
; i end address is: 19 (R19)
L__XBee_AT_Command25:
; i start address is: 19 (R19)
; checksum_temp start address is: 20 (R20)
	LDD        R16, Y+2
	MOV        R18, R16
	SUBI       R18, 254
	CP         R18, R19
	BRSH       L__XBee_AT_Command182
	JMP        L__XBee_AT_Command157
L__XBee_AT_Command182:
;LQd_XBee.mbas,96 :: 		checksum_temp = checksum_temp + packet[i]                                                          ' otestovat checksum temp ako bajt  //////////////////////////////
	MOVW       R16, R28
	MOV        R30, R19
	LDI        R31, 0
	ADD        R30, R16
	ADC        R31, R17
	LD         R16, Z
	LDI        R17, 0
	ADD        R16, R20
	ADC        R17, R21
; checksum_temp end address is: 20 (R20)
; checksum_temp start address is: 22 (R22)
	MOVW       R22, R16
;LQd_XBee.mbas,97 :: 		next i
	CP         R19, R18
	BRNE       L__XBee_AT_Command183
	JMP        L__XBee_AT_Command156
L__XBee_AT_Command183:
	MOV        R16, R19
	SUBI       R16, 255
	MOV        R19, R16
	MOVW       R20, R22
; checksum_temp end address is: 22 (R22)
; i end address is: 19 (R19)
	JMP        L__XBee_AT_Command25
L__XBee_AT_Command156:
	MOV        R19, R22
	MOV        R20, R23
	JMP        L__XBee_AT_Command29
L__XBee_AT_Command157:
;LQd_XBee.mbas,95 :: 		for i = 3 to (packet[2] + 2)
	MOV        R19, R20
	MOV        R20, R21
;LQd_XBee.mbas,97 :: 		next i
L__XBee_AT_Command29:
;LQd_XBee.mbas,98 :: 		packet[packet[2]+3] = 0xFF - Lo(checksum_temp)
; checksum_temp start address is: 19 (R19)
	LDD        R16, Y+2
	MOV        R18, R16
	SUBI       R18, 253
	MOVW       R16, R28
	MOV        R30, R18
	LDI        R31, 0
	ADD        R30, R16
	ADC        R31, R17
	LDI        R16, 255
	SUB        R16, R19
; checksum_temp end address is: 19 (R19)
	ST         Z, R16
;LQd_XBee.mbas,100 :: 		for i = 0 to (packet[2]+3)
; i start address is: 18 (R18)
	LDI        R18, 0
; i end address is: 18 (R18)
L__XBee_AT_Command30:
; i start address is: 18 (R18)
	LDD        R16, Y+2
	SUBI       R16, 253
	STD        Y+12, R16
	CP         R16, R18
	BRSH       L__XBee_AT_Command184
	JMP        L__XBee_AT_Command34
L__XBee_AT_Command184:
;LQd_XBee.mbas,101 :: 		UART2_Write(packet[i])
	MOVW       R16, R28
	MOV        R30, R18
	LDI        R31, 0
	ADD        R30, R16
	ADC        R31, R17
	LD         R16, Z
	PUSH       R2
	MOV        R2, R16
	CALL       _UART2_Write+0
; i end address is: 18 (R18)
	POP        R2
	MOV        R17, R18
;LQd_XBee.mbas,102 :: 		while UART2_Tx_Idle() = 0
	JMP        L__XBee_AT_Command36
L__XBee_AT_Command158:
L__XBee_AT_Command36:
; i start address is: 17 (R17)
; i start address is: 17 (R17)
; i end address is: 17 (R17)
	PUSH       R17
	CALL       _UART2_Tx_Idle+0
	POP        R17
	CPI        R16, 0
	BRNE       L__XBee_AT_Command185
	JMP        L__XBee_AT_Command158
L__XBee_AT_Command185:
; i end address is: 17 (R17)
;LQd_XBee.mbas,104 :: 		next i
; i start address is: 17 (R17)
	LDD        R16, Y+12
	CP         R17, R16
	BRNE       L__XBee_AT_Command186
	JMP        L__XBee_AT_Command34
L__XBee_AT_Command186:
	MOV        R16, R17
	SUBI       R16, 255
; i end address is: 17 (R17)
; i start address is: 18 (R18)
	MOV        R18, R16
; i end address is: 18 (R18)
	JMP        L__XBee_AT_Command30
L__XBee_AT_Command34:
;LQd_XBee.mbas,106 :: 		end sub
L_end_XBee_AT_Command:
	ADIW       R28, 12
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _XBee_AT_Command

_XBee_rx:
	PUSH       R28
	PUSH       R29
	IN         R28, SPL+0
	IN         R29, SPL+1
	SUBI       R28, 135
	SBCI       R29, 0
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	ADIW       R28, 1

;LQd_XBee.mbas,127 :: 		const _MIDDLE = 100
;LQd_XBee.mbas,134 :: 		RTS_Direction = 1         '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	PUSH       R6
	PUSH       R7
	PUSH       R8
	PUSH       R9
	IN         R27, DDD6_bit+0
	SBR        R27, 64
	OUT        DDD6_bit+0, R27
;LQd_XBee.mbas,135 :: 		RTS = 1
	IN         R27, PORTD6_bit+0
	SBR        R27, 64
	OUT        PORTD6_bit+0, R27
;LQd_XBee.mbas,136 :: 		timeout_counter = 0
; timeout_counter start address is: 18 (R18)
	LDI        R18, 0
;LQd_XBee.mbas,137 :: 		memset(@msg, 0, 120)      '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	MOVW       R16, R28
	LDI        R27, 120
	MOV        R5, R27
	LDI        R27, 0
	MOV        R6, R27
	CLR        R4
	MOVW       R2, R16
	CALL       _memset+0
;LQd_XBee.mbas,141 :: 		result = 0
; Result start address is: 16 (R16)
	LDI        R16, 0
; Result end address is: 16 (R16)
;LQd_XBee.mbas,142 :: 		checksum_temp = 0
; checksum_temp start address is: 20 (R20)
	LDI        R20, 0
;LQd_XBee.mbas,144 :: 		hi_adr = 0
; hi_adr start address is: 21 (R21)
	LDI        R21, 0
	LDI        R22, 0
	LDI        R23, 0
	LDI        R24, 0
;LQd_XBee.mbas,145 :: 		lo_adr = 0
	MOVW       R30, R28
	SUBI       R30, 135
	SBCI       R31, 255
	LDI        R27, 0
	ST         Z+, R27
	ST         Z+, R27
	ST         Z+, R27
	ST         Z+, R27
;LQd_XBee.mbas,167 :: 		RTS = 0
	IN         R27, PORTD6_bit+0
	CBR        R27, 64
	OUT        PORTD6_bit+0, R27
; hi_adr end address is: 21 (R21)
; checksum_temp end address is: 20 (R20)
; timeout_counter end address is: 18 (R18)
	MOV        R17, R18
;LQd_XBee.mbas,168 :: 		while UART2_Data_Ready() = 0
L__XBee_rx42:
; hi_adr start address is: 21 (R21)
; checksum_temp start address is: 20 (R20)
; timeout_counter start address is: 17 (R17)
	PUSH       R17
	CALL       _UART2_Data_Ready+0
	POP        R17
	CPI        R16, 0
	BREQ       L__XBee_rx188
	JMP        L__XBee_rx43
L__XBee_rx188:
;LQd_XBee.mbas,169 :: 		Delay_us(_STEP)
	LDI        R16, 53
L__XBee_rx46:
	DEC        R16
	BRNE       L__XBee_rx46
	NOP
;LQd_XBee.mbas,170 :: 		Inc(timeout_counter)
	MOV        R16, R17
	SUBI       R16, 255
	MOV        R17, R16
;LQd_XBee.mbas,171 :: 		if timeout_counter = _MIDDLE then
	CPI        R16, 100
	BREQ       L__XBee_rx189
	JMP        L__XBee_rx49
L__XBee_rx189:
;LQd_XBee.mbas,172 :: 		RTS = 1
	IN         R27, PORTD6_bit+0
	SBR        R27, 64
	OUT        PORTD6_bit+0, R27
L__XBee_rx49:
;LQd_XBee.mbas,174 :: 		if timeout_counter > _MAXTIME then
	LDI        R16, 250
	CP         R16, R17
	BRLO       L__XBee_rx190
	JMP        L__XBee_rx52
L__XBee_rx190:
; timeout_counter end address is: 17 (R17)
; hi_adr end address is: 21 (R21)
; checksum_temp end address is: 20 (R20)
;LQd_XBee.mbas,175 :: 		result = 1                      ' No incoming message
; Result start address is: 17 (R17)
	LDI        R17, 1
;LQd_XBee.mbas,176 :: 		exit
; Result end address is: 17 (R17)
	JMP        L_end__XBee_rx
L__XBee_rx52:
;LQd_XBee.mbas,178 :: 		wend
; checksum_temp start address is: 20 (R20)
; hi_adr start address is: 21 (R21)
; timeout_counter start address is: 17 (R17)
; timeout_counter end address is: 17 (R17)
	JMP        L__XBee_rx42
L__XBee_rx43:
;LQd_XBee.mbas,179 :: 		RTS = 0
	IN         R27, PORTD6_bit+0
	CBR        R27, 64
	OUT        PORTD6_bit+0, R27
;LQd_XBee.mbas,181 :: 		for i = 0 to 2
; i start address is: 19 (R19)
	LDI        R19, 0
; hi_adr end address is: 21 (R21)
; checksum_temp end address is: 20 (R20)
; i end address is: 19 (R19)
L__XBee_rx55:
;LQd_XBee.mbas,182 :: 		msg[i] = UART2_Read()
; i start address is: 19 (R19)
; checksum_temp start address is: 20 (R20)
; hi_adr start address is: 21 (R21)
	MOVW       R16, R28
	ADD        R16, R19
	LDI        R27, 0
	ADC        R17, R27
	MOVW       R30, R28
	SUBI       R30, 124
	SBCI       R31, 255
	ST         Z+, R16
	ST         Z+, R17
	CALL       _UART2_Read+0
	MOVW       R30, R28
	SUBI       R30, 124
	SBCI       R31, 255
	LD         R17, Z+
	LD         R18, Z+
	MOV        R30, R17
	MOV        R31, R18
	ST         Z, R16
;LQd_XBee.mbas,183 :: 		timeout_counter = 0
; timeout_counter start address is: 18 (R18)
	LDI        R18, 0
; hi_adr end address is: 21 (R21)
; checksum_temp end address is: 20 (R20)
; timeout_counter end address is: 18 (R18)
; i end address is: 19 (R19)
;LQd_XBee.mbas,184 :: 		while UART2_Data_Ready() = 0
L__XBee_rx60:
; timeout_counter start address is: 18 (R18)
; hi_adr start address is: 21 (R21)
; checksum_temp start address is: 20 (R20)
; i start address is: 19 (R19)
	CALL       _UART2_Data_Ready+0
	CPI        R16, 0
	BREQ       L__XBee_rx191
	JMP        L__XBee_rx61
L__XBee_rx191:
;LQd_XBee.mbas,185 :: 		Delay_us(_STEP)
	LDI        R16, 53
L__XBee_rx64:
	DEC        R16
	BRNE       L__XBee_rx64
	NOP
;LQd_XBee.mbas,186 :: 		Inc(timeout_counter)
	MOV        R17, R18
	SUBI       R17, 255
	MOV        R18, R17
;LQd_XBee.mbas,187 :: 		if timeout_counter > _MAXTIME then
	LDI        R16, 250
	CP         R16, R17
	BRLO       L__XBee_rx192
	JMP        L__XBee_rx67
L__XBee_rx192:
; hi_adr end address is: 21 (R21)
; checksum_temp end address is: 20 (R20)
; timeout_counter end address is: 18 (R18)
; i end address is: 19 (R19)
;LQd_XBee.mbas,188 :: 		RTS = 1
	IN         R27, PORTD6_bit+0
	SBR        R27, 64
	OUT        PORTD6_bit+0, R27
;LQd_XBee.mbas,190 :: 		result = 4                    'receive timeout, data transmision interrupted
; Result start address is: 17 (R17)
	LDI        R17, 4
;LQd_XBee.mbas,191 :: 		Delay_ms(1000)
	PUSH       R17
	LDI        R18, 41
	LDI        R17, 150
	LDI        R16, 128
L__XBee_rx69:
	DEC        R16
	BRNE       L__XBee_rx69
	DEC        R17
	BRNE       L__XBee_rx69
	DEC        R18
	BRNE       L__XBee_rx69
	POP        R17
;LQd_XBee.mbas,192 :: 		exit
; Result end address is: 17 (R17)
	JMP        L_end__XBee_rx
L__XBee_rx67:
;LQd_XBee.mbas,194 :: 		wend
; i start address is: 19 (R19)
; timeout_counter start address is: 18 (R18)
; checksum_temp start address is: 20 (R20)
; hi_adr start address is: 21 (R21)
; timeout_counter end address is: 18 (R18)
	JMP        L__XBee_rx60
L__XBee_rx61:
;LQd_XBee.mbas,195 :: 		next i
	CPI        R19, 2
	BRNE       L__XBee_rx193
	JMP        L__XBee_rx58
L__XBee_rx193:
	MOV        R16, R19
	SUBI       R16, 255
	MOV        R19, R16
; i end address is: 19 (R19)
	JMP        L__XBee_rx55
L__XBee_rx58:
;LQd_XBee.mbas,196 :: 		msg_lgth = msg[2]
; msg_lgth start address is: 26 (R26)
	LDD        R26, Y+2
;LQd_XBee.mbas,197 :: 		for i = 3 to (msg_lgth + 2)         ' povodne 3
; i start address is: 19 (R19)
	LDI        R19, 3
; hi_adr end address is: 21 (R21)
; checksum_temp end address is: 20 (R20)
; i end address is: 19 (R19)
; msg_lgth end address is: 26 (R26)
	MOV        R10, R21
	MOV        R11, R22
	MOV        R12, R23
	MOV        R13, R24
	MOV        R24, R20
L__XBee_rx71:
; i start address is: 19 (R19)
; msg_lgth start address is: 26 (R26)
; checksum_temp start address is: 24 (R24)
; hi_adr start address is: 10 (R10)
	MOV        R16, R26
	SUBI       R16, 254
	MOVW       R30, R28
	SUBI       R30, 122
	SBCI       R31, 255
	ST         Z, R16
	CP         R16, R19
	BRSH       L__XBee_rx194
	JMP        L__XBee_rx159
L__XBee_rx194:
;LQd_XBee.mbas,198 :: 		msg[i] = UART2_Read()
	MOVW       R16, R28
	ADD        R16, R19
	LDI        R27, 0
	ADC        R17, R27
	MOVW       R30, R28
	SUBI       R30, 124
	SBCI       R31, 255
	ST         Z+, R16
	ST         Z+, R17
	CALL       _UART2_Read+0
	MOVW       R30, R28
	SUBI       R30, 124
	SBCI       R31, 255
	LD         R17, Z+
	LD         R18, Z+
	MOV        R30, R17
	MOV        R31, R18
	ST         Z, R16
;LQd_XBee.mbas,199 :: 		checksum_temp = checksum_temp + msg[i]
	MOVW       R16, R28
	ADD        R16, R19
	LDI        R27, 0
	ADC        R17, R27
	MOVW       R30, R16
	LD         R16, Z
	ADD        R16, R24
; checksum_temp end address is: 24 (R24)
; checksum_temp start address is: 18 (R18)
	MOV        R18, R16
;LQd_XBee.mbas,200 :: 		timeout_counter = 0
; timeout_counter start address is: 25 (R25)
	LDI        R25, 0
; hi_adr end address is: 10 (R10)
; checksum_temp end address is: 18 (R18)
; timeout_counter end address is: 25 (R25)
; i end address is: 19 (R19)
; msg_lgth end address is: 26 (R26)
	MOV        R24, R26
	MOVW       R20, R10
	MOVW       R22, R12
;LQd_XBee.mbas,201 :: 		while UART2_Data_Ready() = 0
L__XBee_rx77:
; timeout_counter start address is: 25 (R25)
; checksum_temp start address is: 18 (R18)
; hi_adr start address is: 20 (R20)
; msg_lgth start address is: 24 (R24)
; i start address is: 19 (R19)
	CALL       _UART2_Data_Ready+0
	CPI        R16, 0
	BREQ       L__XBee_rx195
	JMP        L__XBee_rx78
L__XBee_rx195:
;LQd_XBee.mbas,202 :: 		Delay_us(_STEP)
	LDI        R16, 53
L__XBee_rx81:
	DEC        R16
	BRNE       L__XBee_rx81
	NOP
;LQd_XBee.mbas,203 :: 		Inc(timeout_counter)
	MOV        R17, R25
	SUBI       R17, 255
	MOV        R25, R17
;LQd_XBee.mbas,204 :: 		if timeout_counter > _MAXTIME then
	LDI        R16, 250
	CP         R16, R17
	BRLO       L__XBee_rx196
	JMP        L__XBee_rx84
L__XBee_rx196:
; checksum_temp end address is: 18 (R18)
; hi_adr end address is: 20 (R20)
; msg_lgth end address is: 24 (R24)
; timeout_counter end address is: 25 (R25)
; i end address is: 19 (R19)
;LQd_XBee.mbas,205 :: 		RTS = 1
	IN         R27, PORTD6_bit+0
	SBR        R27, 64
	OUT        PORTD6_bit+0, R27
;LQd_XBee.mbas,207 :: 		result = 4                    'receive timeout, data transmision interrupted
; Result start address is: 17 (R17)
	LDI        R17, 4
;LQd_XBee.mbas,208 :: 		Delay_ms(1000)
	PUSH       R17
	LDI        R18, 41
	LDI        R17, 150
	LDI        R16, 128
L__XBee_rx86:
	DEC        R16
	BRNE       L__XBee_rx86
	DEC        R17
	BRNE       L__XBee_rx86
	DEC        R18
	BRNE       L__XBee_rx86
	POP        R17
;LQd_XBee.mbas,209 :: 		exit
; Result end address is: 17 (R17)
	JMP        L_end__XBee_rx
L__XBee_rx84:
;LQd_XBee.mbas,211 :: 		wend
; i start address is: 19 (R19)
; timeout_counter start address is: 25 (R25)
; msg_lgth start address is: 24 (R24)
; hi_adr start address is: 20 (R20)
; checksum_temp start address is: 18 (R18)
; timeout_counter end address is: 25 (R25)
	JMP        L__XBee_rx77
L__XBee_rx78:
;LQd_XBee.mbas,212 :: 		next i
	MOVW       R30, R28
	SUBI       R30, 122
	SBCI       R31, 255
	LD         R16, Z
	CP         R19, R16
	BRNE       L__XBee_rx197
	JMP        L__XBee_rx160
L__XBee_rx197:
	MOV        R16, R19
	SUBI       R16, 255
	MOV        R19, R16
	MOVW       R10, R20
	MOVW       R12, R22
; checksum_temp end address is: 18 (R18)
; hi_adr end address is: 20 (R20)
; msg_lgth end address is: 24 (R24)
; i end address is: 19 (R19)
	MOV        R26, R24
	MOV        R24, R18
	JMP        L__XBee_rx71
L__XBee_rx159:
;LQd_XBee.mbas,197 :: 		for i = 3 to (msg_lgth + 2)         ' povodne 3
	MOVW       R18, R10
	MOVW       R20, R12
	MOV        R22, R24
;LQd_XBee.mbas,212 :: 		next i
	JMP        L__XBee_rx75
L__XBee_rx160:
	PUSH       R18
	MOVW       R18, R20
	MOVW       R20, R22
	MOV        R26, R24
	POP        R22
L__XBee_rx75:
;LQd_XBee.mbas,213 :: 		checksum = UART2_Read()
; hi_adr start address is: 18 (R18)
; checksum_temp start address is: 22 (R22)
; msg_lgth start address is: 26 (R26)
	CALL       _UART2_Read+0
;LQd_XBee.mbas,214 :: 		RTS = 1
	IN         R27, PORTD6_bit+0
	SBR        R27, 64
	OUT        PORTD6_bit+0, R27
;LQd_XBee.mbas,216 :: 		if (0xFF - checksum_temp) <> checksum then
	LDI        R17, 255
	SUB        R17, R22
; checksum_temp end address is: 22 (R22)
	CP         R17, R16
	BRNE       L__XBee_rx198
	JMP        L__XBee_rx89
L__XBee_rx198:
; hi_adr end address is: 18 (R18)
; msg_lgth end address is: 26 (R26)
;LQd_XBee.mbas,217 :: 		result = 5                                ' ERROR: checksum incorrect
; Result start address is: 17 (R17)
	LDI        R17, 5
;LQd_XBee.mbas,218 :: 		exit
; Result end address is: 17 (R17)
	JMP        L_end__XBee_rx
L__XBee_rx89:
;LQd_XBee.mbas,221 :: 		if msg[0] = 0x7E then
; msg_lgth start address is: 26 (R26)
; hi_adr start address is: 18 (R18)
	LDD        R16, Y+0
	CPI        R16, 126
	BREQ       L__XBee_rx199
	JMP        L__XBee_rx92
L__XBee_rx199:
;LQd_XBee.mbas,222 :: 		frame_type = msg[3]
; frame_type start address is: 3 (R3)
	LDD        R3, Y+3
;LQd_XBee.mbas,223 :: 		frame_id = msg[4]
; frame_id start address is: 24 (R24)
	LDD        R24, Y+4
;LQd_XBee.mbas,225 :: 		if (frame_type = 0x90) OR (frame_type = 0x95) OR (frame_type = 0x97) then
	LDD        R16, Y+3
	CPI        R16, 144
	LDI        R17, 0
	BRNE       L__XBee_rx200
	LDI        R17, 255
L__XBee_rx200:
	LDD        R16, Y+3
	CPI        R16, 149
	LDI        R27, 0
	BRNE       L__XBee_rx201
	LDI        R27, 255
L__XBee_rx201:
	MOV        R16, R27
	OR         R17, R16
	LDD        R16, Y+3
	CPI        R16, 151
	LDI        R27, 0
	BRNE       L__XBee_rx202
	LDI        R27, 255
L__XBee_rx202:
	MOV        R16, R27
	OR         R16, R17
	TST        R16
	BRNE       L__XBee_rx203
	JMP        L__XBee_rx163
L__XBee_rx203:
; hi_adr end address is: 18 (R18)
;LQd_XBee.mbas,226 :: 		if frame_type = 0x90 then
	LDI        R27, 144
	CP         R3, R27
	BREQ       L__XBee_rx204
	JMP        L__XBee_rx98
L__XBee_rx204:
;LQd_XBee.mbas,227 :: 		a = 5
; a start address is: 21 (R21)
	LDI        R21, 5
;LQd_XBee.mbas,228 :: 		b = 7
; b start address is: 4 (R4)
	LDI        R27, 7
	MOV        R4, R27
	MOV        R20, R21
; a end address is: 21 (R21)
; b end address is: 4 (R4)
	JMP        L__XBee_rx99
;LQd_XBee.mbas,229 :: 		else
L__XBee_rx98:
;LQd_XBee.mbas,230 :: 		a = 6
; a start address is: 21 (R21)
	LDI        R21, 6
;LQd_XBee.mbas,231 :: 		b = 8
; b start address is: 4 (R4)
	LDI        R27, 8
	MOV        R4, R27
; a end address is: 21 (R21)
; b end address is: 4 (R4)
	MOV        R20, R21
;LQd_XBee.mbas,232 :: 		end if
L__XBee_rx99:
;LQd_XBee.mbas,233 :: 		hi_adr = msg[a - 1]
; b start address is: 4 (R4)
; a start address is: 20 (R20)
	MOV        R16, R20
	SUBI       R16, 1
	MOVW       R18, R28
	LDI        R17, 0
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LD         R16, Z
; hi_adr start address is: 5 (R5)
	MOV        R5, R16
	LDI        R27, 0
	MOV        R6, R27
	MOV        R7, R6
	MOV        R8, R6
;LQd_XBee.mbas,234 :: 		lo_adr = msg[a + 3]
	MOV        R16, R20
	SUBI       R16, 253
	LDI        R17, 0
	ADD        R16, R18
	ADC        R17, R19
	MOVW       R30, R16
	LD         R16, Z
	MOVW       R30, R28
	SUBI       R30, 135
	SBCI       R31, 255
	ST         Z+, R16
	LDI        R27, 0
	ST         Z+, R27
	ST         Z+, R27
	ST         Z+, R27
;LQd_XBee.mbas,235 :: 		for i = a to b
; i start address is: 9 (R9)
	MOV        R9, R20
; a end address is: 20 (R20)
; b end address is: 4 (R4)
; frame_type end address is: 3 (R3)
; hi_adr end address is: 5 (R5)
; i end address is: 9 (R9)
; frame_id end address is: 24 (R24)
; msg_lgth end address is: 26 (R26)
	MOV        R2, R24
	MOV        R16, R5
	MOV        R17, R6
	MOV        R18, R7
	MOV        R19, R8
L__XBee_rx100:
; i start address is: 9 (R9)
; hi_adr start address is: 16 (R16)
; b start address is: 4 (R4)
; frame_id start address is: 2 (R2)
; frame_type start address is: 3 (R3)
; msg_lgth start address is: 26 (R26)
	CP         R4, R9
	BRSH       L__XBee_rx205
	JMP        L__XBee_rx162
L__XBee_rx205:
;LQd_XBee.mbas,236 :: 		hi_adr = hi_adr << 8
	MOV        R23, R18
	MOV        R22, R17
	MOV        R21, R16
	CLR        R20
; hi_adr end address is: 16 (R16)
;LQd_XBee.mbas,237 :: 		hi_adr = hi_adr + msg[i]
	MOVW       R24, R28
	MOV        R16, R9
	LDI        R17, 0
	ADD        R16, R24
	ADC        R17, R25
	MOVW       R30, R16
	LD         R16, Z
	LDI        R17, 0
	MOV        R18, R17
	MOV        R19, R17
	ADD        R16, R20
	ADC        R17, R21
	ADC        R18, R22
	ADC        R19, R23
; hi_adr start address is: 5 (R5)
	MOV        R5, R16
	MOV        R6, R17
	MOV        R7, R18
	MOV        R8, R19
;LQd_XBee.mbas,238 :: 		lo_adr = lo_adr << 8
	MOVW       R30, R28
	SUBI       R30, 135
	SBCI       R31, 255
	LD         R16, Z+
	LD         R17, Z+
	LD         R18, Z+
	LD         R19, Z+
	MOV        R23, R18
	MOV        R22, R17
	MOV        R21, R16
	CLR        R20
;LQd_XBee.mbas,239 :: 		lo_adr = lo_adr + msg[i + 4]
	MOV        R16, R9
	SUBI       R16, 252
	LDI        R17, 0
	ADD        R16, R24
	ADC        R17, R25
	MOVW       R30, R16
	LD         R16, Z
	LDI        R17, 0
	MOV        R18, R17
	MOV        R19, R17
	ADD        R16, R20
	ADC        R17, R21
	ADC        R18, R22
	ADC        R19, R23
	MOVW       R30, R28
	SUBI       R30, 135
	SBCI       R31, 255
	ST         Z+, R16
	ST         Z+, R17
	ST         Z+, R18
	ST         Z+, R19
;LQd_XBee.mbas,240 :: 		next i
	CP         R9, R4
	BRNE       L__XBee_rx206
	JMP        L__XBee_rx161
L__XBee_rx206:
	MOV        R16, R9
	SUBI       R16, 255
	MOV        R9, R16
; b end address is: 4 (R4)
; hi_adr end address is: 5 (R5)
; i end address is: 9 (R9)
	MOV        R16, R5
	MOV        R17, R6
	MOV        R18, R7
	MOV        R19, R8
	JMP        L__XBee_rx100
L__XBee_rx161:
	MOV        R16, R5
	MOV        R17, R6
	MOV        R18, R7
	MOV        R19, R8
	JMP        L__XBee_rx104
L__XBee_rx162:
;LQd_XBee.mbas,235 :: 		for i = a to b
;LQd_XBee.mbas,240 :: 		next i
L__XBee_rx104:
; hi_adr start address is: 16 (R16)
	MOV        R5, R19
; frame_id end address is: 2 (R2)
; frame_type end address is: 3 (R3)
; hi_adr end address is: 16 (R16)
; msg_lgth end address is: 26 (R26)
	MOV        R4, R18
	MOV        R24, R2
	MOV        R2, R16
	MOV        R16, R3
	MOV        R3, R17
	JMP        L__XBee_rx95
L__XBee_rx163:
;LQd_XBee.mbas,225 :: 		if (frame_type = 0x90) OR (frame_type = 0x95) OR (frame_type = 0x97) then
	MOV        R16, R3
	MOVW       R2, R18
	MOVW       R4, R20
;LQd_XBee.mbas,240 :: 		next i
L__XBee_rx95:
;LQd_XBee.mbas,244 :: 		case 0x88   'AT command response
; frame_id start address is: 24 (R24)
; frame_type start address is: 16 (R16)
; msg_lgth start address is: 26 (R26)
; hi_adr start address is: 2 (R2)
	CPI        R16, 136
	BREQ       L__XBee_rx207
	JMP        L__XBee_rx108
L__XBee_rx207:
; frame_type end address is: 16 (R16)
; hi_adr end address is: 2 (R2)
;LQd_XBee.mbas,245 :: 		memset(@ATcommand, 0, 3)
	MOVW       R16, R28
	SUBI       R16, 131
	SBCI       R17, 255
	LDI        R27, 3
	MOV        R5, R27
	LDI        R27, 0
	MOV        R6, R27
	CLR        R4
	MOVW       R2, R16
	CALL       _memset+0
;LQd_XBee.mbas,246 :: 		ATcommand[0] = msg[5]
	LDD        R16, Y+5
	MOVW       R30, R28
	SUBI       R30, 131
	SBCI       R31, 255
	ST         Z, R16
;LQd_XBee.mbas,247 :: 		ATcommand[1] = msg[6]
	LDD        R16, Y+6
	MOVW       R30, R28
	SUBI       R30, 130
	SBCI       R31, 255
	ST         Z, R16
;LQd_XBee.mbas,252 :: 		ATcommand_parameter = 0
; ATcommand_parameter start address is: 17 (R17)
	LDI        R17, 0
	LDI        R18, 0
	LDI        R19, 0
	LDI        R20, 0
;LQd_XBee.mbas,253 :: 		if msg_lgth > 5 then           'if the register was set, then this field is not returned, and ATcommand_parameter = 0
	LDI        R16, 5
	CP         R16, R26
	BRLO       L__XBee_rx208
	JMP        L__XBee_rx167
L__XBee_rx208:
; ATcommand_parameter end address is: 17 (R17)
;LQd_XBee.mbas,254 :: 		ATcommand_parameter = msg[8]
; ATcommand_parameter start address is: 2 (R2)
	LDD        R2, Y+8
	LDI        R27, 0
	MOV        R3, R27
	MOV        R4, R3
	MOV        R5, R3
;LQd_XBee.mbas,255 :: 		if msg_lgth > 6 then
	LDI        R16, 6
	CP         R16, R26
	BRLO       L__XBee_rx209
	JMP        L__XBee_rx166
L__XBee_rx209:
;LQd_XBee.mbas,256 :: 		ATcommand_parameter = ATcommand_parameter << 8
	MOV        R23, R4
	MOV        R22, R3
	MOV        R21, R2
	CLR        R20
; ATcommand_parameter end address is: 2 (R2)
;LQd_XBee.mbas,257 :: 		ATcommand_parameter = ATcommand_parameter + msg[9]
	LDD        R16, Y+9
	LDI        R17, 0
	MOV        R18, R17
	MOV        R19, R17
	ADD        R16, R20
	ADC        R17, R21
	ADC        R18, R22
	ADC        R19, R23
; ATcommand_parameter start address is: 2 (R2)
	MOVW       R2, R16
	MOVW       R4, R18
;LQd_XBee.mbas,258 :: 		if msg_lgth > 7 then
	LDI        R16, 7
	CP         R16, R26
	BRLO       L__XBee_rx210
	JMP        L__XBee_rx165
L__XBee_rx210:
;LQd_XBee.mbas,259 :: 		ATcommand_parameter = ATcommand_parameter << 8
	MOV        R23, R4
	MOV        R22, R3
	MOV        R21, R2
	CLR        R20
; ATcommand_parameter end address is: 2 (R2)
;LQd_XBee.mbas,260 :: 		ATcommand_parameter = ATcommand_parameter + msg[10]
	LDD        R16, Y+10
	LDI        R17, 0
	MOV        R18, R17
	MOV        R19, R17
	ADD        R16, R20
	ADC        R17, R21
	ADC        R18, R22
	ADC        R19, R23
; ATcommand_parameter start address is: 2 (R2)
	MOVW       R2, R16
	MOVW       R4, R18
;LQd_XBee.mbas,261 :: 		if msg_lgth > 8 then
	LDI        R16, 8
	CP         R16, R26
	BRLO       L__XBee_rx211
	JMP        L__XBee_rx164
L__XBee_rx211:
; msg_lgth end address is: 26 (R26)
;LQd_XBee.mbas,262 :: 		ATcommand_parameter = ATcommand_parameter << 8
	MOV        R23, R4
	MOV        R22, R3
	MOV        R21, R2
	CLR        R20
; ATcommand_parameter end address is: 2 (R2)
;LQd_XBee.mbas,263 :: 		ATcommand_parameter = ATcommand_parameter + msg[11]
	LDD        R16, Y+11
	LDI        R17, 0
	MOV        R18, R17
	MOV        R19, R17
	ADD        R16, R20
	ADC        R17, R21
	ADC        R18, R22
	ADC        R19, R23
; ATcommand_parameter start address is: 20 (R20)
	MOVW       R20, R16
	MOVW       R22, R18
; ATcommand_parameter end address is: 20 (R20)
	MOVW       R16, R20
	MOVW       R18, R22
	JMP        L__XBee_rx119
L__XBee_rx164:
;LQd_XBee.mbas,261 :: 		if msg_lgth > 8 then
	MOVW       R16, R2
	MOVW       R18, R4
;LQd_XBee.mbas,263 :: 		ATcommand_parameter = ATcommand_parameter + msg[11]
L__XBee_rx119:
;LQd_XBee.mbas,264 :: 		end if
; ATcommand_parameter start address is: 16 (R16)
; ATcommand_parameter end address is: 16 (R16)
	JMP        L__XBee_rx116
L__XBee_rx165:
;LQd_XBee.mbas,258 :: 		if msg_lgth > 7 then
	MOVW       R16, R2
	MOVW       R18, R4
;LQd_XBee.mbas,264 :: 		end if
L__XBee_rx116:
;LQd_XBee.mbas,265 :: 		end if
; ATcommand_parameter start address is: 16 (R16)
; ATcommand_parameter end address is: 16 (R16)
	JMP        L__XBee_rx113
L__XBee_rx166:
;LQd_XBee.mbas,255 :: 		if msg_lgth > 6 then
	MOVW       R16, R2
	MOVW       R18, R4
;LQd_XBee.mbas,265 :: 		end if
L__XBee_rx113:
;LQd_XBee.mbas,266 :: 		end if
; ATcommand_parameter start address is: 16 (R16)
; ATcommand_parameter end address is: 16 (R16)
	JMP        L__XBee_rx110
L__XBee_rx167:
;LQd_XBee.mbas,253 :: 		if msg_lgth > 5 then           'if the register was set, then this field is not returned, and ATcommand_parameter = 0
	MOV        R16, R17
	MOV        R17, R18
	MOV        R18, R19
	MOV        R19, R20
;LQd_XBee.mbas,266 :: 		end if
L__XBee_rx110:
;LQd_XBee.mbas,269 :: 		XBee_AT_command_response(frame_id, ATcommand, msg[7], ATcommand_parameter)
; ATcommand_parameter start address is: 16 (R16)
	MOVW       R6, R16
	MOVW       R8, R18
; ATcommand_parameter end address is: 16 (R16)
	LDD        R5, Y+7
	MOVW       R16, R28
	SUBI       R16, 131
	SBCI       R17, 255
	MOV        R3, R16
	MOV        R4, R17
	MOV        R2, R24
; frame_id end address is: 24 (R24)
	CALL       _XBee_AT_command_response+0
	JMP        L__XBee_rx105
L__XBee_rx108:
;LQd_XBee.mbas,274 :: 		case 0x8A   'Modem status
; msg_lgth start address is: 26 (R26)
; hi_adr start address is: 2 (R2)
; frame_type start address is: 16 (R16)
; frame_id start address is: 24 (R24)
	CPI        R16, 138
	BREQ       L__XBee_rx212
	JMP        L__XBee_rx123
L__XBee_rx212:
; frame_id end address is: 24 (R24)
; frame_type end address is: 16 (R16)
; hi_adr end address is: 2 (R2)
; msg_lgth end address is: 26 (R26)
;LQd_XBee.mbas,275 :: 		XBee_modem_status(msg[4])
	LDD        R2, Y+4
	CALL       _XBee_modem_status+0
	JMP        L__XBee_rx105
L__XBee_rx123:
;LQd_XBee.mbas,281 :: 		case 0x8B   'TX status
; msg_lgth start address is: 26 (R26)
; hi_adr start address is: 2 (R2)
; frame_type start address is: 16 (R16)
; frame_id start address is: 24 (R24)
	CPI        R16, 139
	BREQ       L__XBee_rx213
	JMP        L__XBee_rx126
L__XBee_rx213:
; frame_id end address is: 24 (R24)
; frame_type end address is: 16 (R16)
; hi_adr end address is: 2 (R2)
; msg_lgth end address is: 26 (R26)
;LQd_XBee.mbas,282 :: 		XBee_transmit_status(msg[4], msg[7], msg[8], msg[9])
	LDD        R5, Y+9
	LDD        R4, Y+8
	LDD        R3, Y+7
	LDD        R2, Y+4
	CALL       _XBee_transmit_status+0
	JMP        L__XBee_rx105
L__XBee_rx126:
;LQd_XBee.mbas,293 :: 		case 0x90   'Receive packet
; msg_lgth start address is: 26 (R26)
; hi_adr start address is: 2 (R2)
; frame_type start address is: 16 (R16)
; frame_id start address is: 24 (R24)
	CPI        R16, 144
	BREQ       L__XBee_rx214
	JMP        L__XBee_rx129
L__XBee_rx214:
; frame_id end address is: 24 (R24)
; frame_type end address is: 16 (R16)
;LQd_XBee.mbas,294 :: 		Receive_options = msg[14]
; Receive_options start address is: 21 (R21)
	LDD        R21, Y+14
;LQd_XBee.mbas,297 :: 		for i = 15 to (msg_lgth + 2)
; i start address is: 22 (R22)
	LDI        R22, 15
; i end address is: 22 (R22)
; Receive_options end address is: 21 (R21)
; hi_adr end address is: 2 (R2)
; msg_lgth end address is: 26 (R26)
L__XBee_rx130:
; i start address is: 22 (R22)
; Receive_options start address is: 21 (R21)
; hi_adr start address is: 2 (R2)
; msg_lgth start address is: 26 (R26)
	MOV        R20, R26
	SUBI       R20, 254
	CP         R20, R22
	BRSH       L__XBee_rx215
	JMP        L__XBee_rx134
L__XBee_rx215:
;LQd_XBee.mbas,298 :: 		msg[i-15] = msg[i]
	MOV        R18, R22
	SUBI       R18, 15
	MOVW       R16, R28
	LDI        R19, 0
	ADD        R18, R16
	ADC        R19, R17
	ADD        R16, R22
	LDI        R27, 0
	ADC        R17, R27
	MOVW       R30, R16
	LD         R16, Z
	MOVW       R30, R18
	ST         Z, R16
;LQd_XBee.mbas,299 :: 		next i
	CP         R22, R20
	BRNE       L__XBee_rx216
	JMP        L__XBee_rx134
L__XBee_rx216:
	MOV        R16, R22
	SUBI       R16, 255
; i end address is: 22 (R22)
; i start address is: 6 (R6)
	MOV        R6, R16
; i end address is: 6 (R6)
	MOV        R22, R6
	JMP        L__XBee_rx130
L__XBee_rx134:
;LQd_XBee.mbas,300 :: 		msg[msg_lgth+3-15] = 0
	MOV        R16, R26
	SUBI       R16, 253
	MOV        R18, R16
	SUBI       R18, 15
	MOVW       R16, R28
	ADD        R16, R18
	LDI        R27, 0
	ADC        R17, R27
	MOVW       R30, R16
	LDI        R27, 0
	ST         Z, R27
;LQd_XBee.mbas,301 :: 		XBee_receive_packet(hi_adr, lo_adr, Receive_options, msg, (msg_lgth + 3 - 15))
	MOV        R16, R26
	SUBI       R16, 253
; msg_lgth end address is: 26 (R26)
	MOV        R18, R16
	SUBI       R18, 15
	MOVW       R16, R28
	MOVW       R30, R28
	SUBI       R30, 135
	SBCI       R31, 255
	LD         R6, Z+
	LD         R7, Z+
	LD         R8, Z+
	LD         R9, Z+
; hi_adr end address is: 2 (R2)
	PUSH       R18
	PUSH       R17
	PUSH       R16
	PUSH       R21
; Receive_options end address is: 21 (R21)
	CALL       _XBee_receive_packet+0
	IN         R26, SPL+0
	IN         R27, SPL+1
	ADIW       R26, 4
	OUT        SPL+0, R26
	OUT        SPL+1, R27
	JMP        L__XBee_rx105
L__XBee_rx129:
;LQd_XBee.mbas,303 :: 		case 0x95   'Node identifier indicator
; msg_lgth start address is: 26 (R26)
; hi_adr start address is: 2 (R2)
; frame_type start address is: 16 (R16)
; frame_id start address is: 24 (R24)
	CPI        R16, 149
	BREQ       L__XBee_rx217
	JMP        L__XBee_rx137
L__XBee_rx217:
; frame_id end address is: 24 (R24)
; frame_type end address is: 16 (R16)
; hi_adr end address is: 2 (R2)
; msg_lgth end address is: 26 (R26)
;LQd_XBee.mbas,304 :: 		RTS = 1
	IN         R27, PORTD6_bit+0
	SBR        R27, 64
	OUT        PORTD6_bit+0, R27
;LQd_XBee.mbas,305 :: 		result = 3   ' ERROR: Unknown frame type, NOT IMPLEMENTED YET
; Result start address is: 17 (R17)
	LDI        R17, 3
;LQd_XBee.mbas,306 :: 		exit
; Result end address is: 17 (R17)
	JMP        L_end__XBee_rx
L__XBee_rx137:
;LQd_XBee.mbas,307 :: 		case 0x97   'Remote command response
; msg_lgth start address is: 26 (R26)
; hi_adr start address is: 2 (R2)
; frame_type start address is: 16 (R16)
; frame_id start address is: 24 (R24)
	CPI        R16, 151
	BREQ       L__XBee_rx218
	JMP        L__XBee_rx140
L__XBee_rx218:
; frame_type end address is: 16 (R16)
;LQd_XBee.mbas,308 :: 		memset(@ATcommand, 0, 3)
	MOVW       R16, R28
	SUBI       R16, 131
	SBCI       R17, 255
	PUSH       R5
	PUSH       R4
	PUSH       R3
	PUSH       R2
	LDI        R27, 3
	MOV        R5, R27
	LDI        R27, 0
	MOV        R6, R27
	CLR        R4
	MOVW       R2, R16
	CALL       _memset+0
	POP        R2
	POP        R3
	POP        R4
	POP        R5
;LQd_XBee.mbas,309 :: 		ATcommand[0] = msg[15]
	LDD        R16, Y+15
	MOVW       R30, R28
	SUBI       R30, 131
	SBCI       R31, 255
	ST         Z, R16
;LQd_XBee.mbas,310 :: 		ATcommand[1] = msg[16]
	LDD        R16, Y+16
	MOVW       R30, R28
	SUBI       R30, 130
	SBCI       R31, 255
	ST         Z, R16
;LQd_XBee.mbas,311 :: 		status = msg[17]                'command status: 0 = OK
; status start address is: 25 (R25)
	LDD        R25, Y+17
;LQd_XBee.mbas,315 :: 		ATcommand_parameter = 0
; ATcommand_parameter start address is: 18 (R18)
	LDI        R18, 0
	LDI        R19, 0
	LDI        R20, 0
	LDI        R21, 0
;LQd_XBee.mbas,316 :: 		if msg_lgth > 14 then           'if the register was set, then this field is not returned, and ATcommand_parameter = 0
	LDI        R16, 14
	CP         R16, R26
	BRLO       L__XBee_rx219
	JMP        L__XBee_rx171
L__XBee_rx219:
; ATcommand_parameter end address is: 18 (R18)
;LQd_XBee.mbas,317 :: 		ATcommand_parameter = msg[17]
; ATcommand_parameter start address is: 6 (R6)
	LDD        R6, Y+17
	LDI        R27, 0
	MOV        R7, R27
	MOV        R8, R7
	MOV        R9, R7
;LQd_XBee.mbas,318 :: 		if msg_lgth > 15 then
	LDI        R16, 15
	CP         R16, R26
	BRLO       L__XBee_rx220
	JMP        L__XBee_rx170
L__XBee_rx220:
;LQd_XBee.mbas,319 :: 		ATcommand_parameter = ATcommand_parameter << 8
	MOV        R23, R8
	MOV        R22, R7
	MOV        R21, R6
	CLR        R20
; ATcommand_parameter end address is: 6 (R6)
;LQd_XBee.mbas,320 :: 		ATcommand_parameter = ATcommand_parameter + msg[18]
	LDD        R16, Y+18
	LDI        R17, 0
	MOV        R18, R17
	MOV        R19, R17
	ADD        R16, R20
	ADC        R17, R21
	ADC        R18, R22
	ADC        R19, R23
; ATcommand_parameter start address is: 6 (R6)
	MOVW       R6, R16
	MOVW       R8, R18
;LQd_XBee.mbas,321 :: 		if msg_lgth > 16 then
	LDI        R16, 16
	CP         R16, R26
	BRLO       L__XBee_rx221
	JMP        L__XBee_rx169
L__XBee_rx221:
;LQd_XBee.mbas,322 :: 		ATcommand_parameter = ATcommand_parameter << 8
	MOV        R23, R8
	MOV        R22, R7
	MOV        R21, R6
	CLR        R20
; ATcommand_parameter end address is: 6 (R6)
;LQd_XBee.mbas,323 :: 		ATcommand_parameter = ATcommand_parameter + msg[19]
	LDD        R16, Y+19
	LDI        R17, 0
	MOV        R18, R17
	MOV        R19, R17
	ADD        R16, R20
	ADC        R17, R21
	ADC        R18, R22
	ADC        R19, R23
; ATcommand_parameter start address is: 6 (R6)
	MOVW       R6, R16
	MOVW       R8, R18
;LQd_XBee.mbas,324 :: 		if msg_lgth > 17 then
	LDI        R16, 17
	CP         R16, R26
	BRLO       L__XBee_rx222
	JMP        L__XBee_rx168
L__XBee_rx222:
; msg_lgth end address is: 26 (R26)
;LQd_XBee.mbas,325 :: 		ATcommand_parameter = ATcommand_parameter << 8
	MOV        R23, R8
	MOV        R22, R7
	MOV        R21, R6
	CLR        R20
; ATcommand_parameter end address is: 6 (R6)
;LQd_XBee.mbas,326 :: 		ATcommand_parameter = ATcommand_parameter + msg[20]
	LDD        R16, Y+20
	LDI        R17, 0
	MOV        R18, R17
	MOV        R19, R17
	ADD        R16, R20
	ADC        R17, R21
	ADC        R18, R22
	ADC        R19, R23
; ATcommand_parameter start address is: 20 (R20)
	MOVW       R20, R16
	MOVW       R22, R18
; ATcommand_parameter end address is: 20 (R20)
	MOVW       R16, R20
	MOVW       R18, R22
	JMP        L__XBee_rx151
L__XBee_rx168:
;LQd_XBee.mbas,324 :: 		if msg_lgth > 17 then
	MOVW       R16, R6
	MOVW       R18, R8
;LQd_XBee.mbas,326 :: 		ATcommand_parameter = ATcommand_parameter + msg[20]
L__XBee_rx151:
;LQd_XBee.mbas,327 :: 		end if
; ATcommand_parameter start address is: 16 (R16)
	MOVW       R20, R18
	MOVW       R18, R16
; ATcommand_parameter end address is: 16 (R16)
	JMP        L__XBee_rx148
L__XBee_rx169:
;LQd_XBee.mbas,321 :: 		if msg_lgth > 16 then
	MOVW       R18, R6
	MOVW       R20, R8
;LQd_XBee.mbas,327 :: 		end if
L__XBee_rx148:
;LQd_XBee.mbas,328 :: 		end if
; ATcommand_parameter start address is: 18 (R18)
; ATcommand_parameter end address is: 18 (R18)
	JMP        L__XBee_rx145
L__XBee_rx170:
;LQd_XBee.mbas,318 :: 		if msg_lgth > 15 then
	MOVW       R18, R6
	MOVW       R20, R8
;LQd_XBee.mbas,328 :: 		end if
L__XBee_rx145:
;LQd_XBee.mbas,329 :: 		end if
; ATcommand_parameter start address is: 18 (R18)
; ATcommand_parameter end address is: 18 (R18)
	JMP        L__XBee_rx142
L__XBee_rx171:
;LQd_XBee.mbas,316 :: 		if msg_lgth > 14 then           'if the register was set, then this field is not returned, and ATcommand_parameter = 0
;LQd_XBee.mbas,329 :: 		end if
L__XBee_rx142:
;LQd_XBee.mbas,331 :: 		Xbee_remote_command_response(frame_id, hi_adr, lo_adr, ATcommand, status, ATcommand_parameter)
; ATcommand_parameter start address is: 18 (R18)
	MOVW       R16, R28
	SUBI       R16, 131
	SBCI       R17, 255
	MOV        R6, R5
	MOV        R5, R4
	MOV        R4, R3
	MOV        R3, R2
; hi_adr end address is: 2 (R2)
	MOV        R2, R24
; frame_id end address is: 24 (R24)
	PUSH       R21
	PUSH       R20
	PUSH       R19
	PUSH       R18
; ATcommand_parameter end address is: 18 (R18)
	PUSH       R25
; status end address is: 25 (R25)
	PUSH       R17
	PUSH       R16
	MOVW       R30, R28
	SUBI       R30, 135
	SBCI       R31, 255
	LD         R16, Z+
	LD         R17, Z+
	LD         R18, Z+
	LD         R19, Z+
	PUSH       R19
	PUSH       R18
	PUSH       R17
	PUSH       R16
	CALL       _Xbee_remote_command_response+0
	IN         R26, SPL+0
	IN         R27, SPL+1
	ADIW       R26, 11
	OUT        SPL+0, R26
	OUT        SPL+1, R27
	JMP        L__XBee_rx105
L__XBee_rx140:
;LQd_XBee.mbas,333 :: 		result = 3   ' ERROR: Unknown frame type
; Result start address is: 17 (R17)
	LDI        R17, 3
;LQd_XBee.mbas,334 :: 		exit
; Result end address is: 17 (R17)
	JMP        L_end__XBee_rx
L__XBee_rx105:
;LQd_XBee.mbas,337 :: 		result = 0    ' incoming message is processed
; Result start address is: 17 (R17)
	LDI        R17, 0
	JMP        L__XBee_rx93
; Result end address is: 17 (R17)
;LQd_XBee.mbas,338 :: 		else
L__XBee_rx92:
;LQd_XBee.mbas,339 :: 		result = 2    ' ERROR: message not start with 0x7E
; Result start address is: 17 (R17)
	LDI        R17, 2
;LQd_XBee.mbas,340 :: 		exit
	JMP        L_end__XBee_rx
;LQd_XBee.mbas,341 :: 		end if
L__XBee_rx93:
;LQd_XBee.mbas,349 :: 		end sub
L_end__XBee_rx:
; Result end address is: 17 (R17)
; Result start address is: 17 (R17)
	MOV        R16, R17
; Result end address is: 17 (R17)
L_end_XBee_rx:
	POP        R9
	POP        R8
	POP        R7
	POP        R6
	POP        R5
	POP        R4
	POP        R3
	POP        R2
	SUBI       R28, 122
	SBCI       R29, 255
	OUT        SPL+0, R28
	OUT        SPL+1, R29
	POP        R29
	POP        R28
	RET
; end of _XBee_rx

_LQd_XBee_?main:

;LQd_XBee.mbas,351 :: 		end.
L_end_LQd_XBee_?main:
	RET
; end of _LQd_XBee_?main
